/*
 * modbus-tcp - buffer.h
 *	version 0.1.0
 *
 * Copyright (C) 2010  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __BUFFER_H
#define __BUFFER_H

#include <stdlib.h>

struct buffer {
	void *data;		/* pointer to data */
	size_t size;		/* number of allocated bytes */
	size_t length;		/* number of used bytes */
	size_t current;		/* current write pointer */
};

int buffer_init(struct buffer *b);
int buffer_alloc(struct buffer *b, size_t size);
ssize_t buffer_read(int fd, struct buffer *b, size_t count);
ssize_t buffer_write(int fd, struct buffer *b);
int buffer_destroy(struct buffer *b);
int buffer_completed(struct buffer *b);
int buffer_skip(struct buffer *b, size_t count);

#endif
